﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	
	Private mListView As ListView
	Private ListData As List

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(LV As ListView)

	mListView = LV
	
	'Link a CellFactory to our list
	Dim CFH As LVCellFactoryHelper
	CFH.Initialize(CFH.TYPETEXT,"Id",LV)
	
End Sub
'Set the data for the list view
Sub setData(Data As List)
	ListData = Data
	SetupListViewCF
End Sub
'initialize the listview with cellfactory objects
Sub SetupListViewCF

	For i = 0 To ListData.Size - 1
		'Add a cellfactoryobject for each row in the array
		Dim CFO As CellFactoryObject
		CFO.Initialize
		mListView.Items.Add(CFO)
	Next
End Sub
#Region Data Access Subs 
Sub getRowData(Index As Int) As Object()
	Return ListData.Get(Index)
End Sub
#End Region Data Access Subs

#Region CellFactory Subs	'########################################################################################################################################

'This sub is used by the cell factory to get the pane to display, You can add UI controls to the AnchorPane.
'The cell is also exposed making it possible to style the cell using CSS inline, or add a style sheet to the cell with JavaObject
'The Id is the one provided in the Helper Initialization, you can make changes based on the ID, or even create a completely different layout for several different lists.
'If the ListViewHelper has a type TYPETEXT, this sub will not be called.
Sub getGraphic(Id As String,Cell As Object) As Object			'Ignore

	#Region Required Code
	'Required - Record the Cell related to this Object once it has been displayed
	
	'Instantiate the Pane or Node to be returned
	Dim P As AnchorPane
	P.Initialize("")
	#End Region Required Code

	'User Code - Create a panel to be returned for display in the ListView cell


	
	#Region Required Code
	'Must Return the Pane or Node to be displayed
	Return P
	#End Region Required Code
End Sub

'This sub is used by the cell factory to get the text to display for this object, you can create a string to return from the fields available or any other code.
'The Id is the one provided in the Helper Initialization, you can make changes to the text based on the ID or use it for different Lists.
'If the ListViewHelper has a type TYPEGRAPHIC, this sub will not be called.
Sub getText(Id As String,LV As Object) As String			
#Region Required Code
	Dim ReturnString As String

	Dim Cell As JavaObject = Sender
	
#End Region Required Code
	
	'User Code
	Dim Row As Int = CellUtilsStatic.RowIndex(Cell)
	If Row = -1 Then Return ""
	Dim RowData() As Object = ListData.Get(Row)
	If Main.getFirstLast Then
		ReturnString = RowData(Main.FirstName) & " " & RowData(Main.LastName) & " " & RowData(Main.Score)
	Else
		ReturnString = RowData(Main.LastName) & " " & RowData(Main.FirstName) & " " & RowData(Main.Score)
	End If
	
	'As the cells are reused as they are displayed, remove any residual styles for this cell
	Cell.RunMethod("setStyle",Array(""))
	
	'Set style on the Cell for the current object
	If RowData(Main.Score) >= 90 Then Cell.RunMethod("setStyle",Array("-fx-background-color: Cyan;"))
	
#Region Required Code
	'Must return a String
	Return ReturnString
#End Region Required code
End Sub

#End Region Cell Factory Subs